Skip to content

Commit

Permalink
Merge pull request kubernetes#2 from neolit123/add-hack
Browse files Browse the repository at this point in the history
hack: add verification scripts for CI
  • Loading branch information
k8s-ci-robot authored Oct 30, 2019
2 parents a7d23ea + 0c0a002 commit 3196c0d
Show file tree
Hide file tree
Showing 17 changed files with 944 additions and 0 deletions.
26 changes: 26 additions & 0 deletions hack/update-all.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,26 @@
#!/usr/bin/env bash
# Copyright 2018 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# script to run all update scripts (except deps)
set -o errexit
set -o nounset
set -o pipefail

# shellcheck source=/dev/null
source "$(dirname "$0")/utils.sh"
REPO_PATH=$(get_root_path)

"${REPO_PATH}"/hack/update-deps.sh
"${REPO_PATH}"/hack/update-gofmt.sh
47 changes: 47 additions & 0 deletions hack/update-deps.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,47 @@
#!/usr/bin/env bash
# Copyright 2018 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# Runs go mod tidy, go mod vendor, and then prun vendor
#
# Usage:
# update-deps.sh

set -o nounset
set -o errexit
set -o pipefail

# shellcheck source=/dev/null
source "$(dirname "$0")/utils.sh"
# cd to the root path
cd_root_path

prune-vendor() {
find vendor -type f \
-not -iname "*.c" \
-not -iname "*.go" \
-not -iname "*.h" \
-not -iname "*.proto" \
-not -iname "*.s" \
-not -iname "AUTHORS*" \
-not -iname "CONTRIBUTORS*" \
-not -iname "COPYING*" \
-not -iname "LICENSE*" \
-not -iname "NOTICE*" \
-exec rm '{}' \;
}

export GO111MODULE="on"
go mod tidy
27 changes: 27 additions & 0 deletions hack/update-gofmt.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,27 @@
#!/usr/bin/env bash
# Copyright 2019 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# script to run gofmt over our code (not vendor)
set -o errexit
set -o nounset
set -o pipefail

# shellcheck source=/dev/null
source "$(dirname "$0")/utils.sh"
# cd to the root path
cd_root_path

# update go fmt
go fmt ./...
24 changes: 24 additions & 0 deletions hack/utils.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,24 @@
#!/usr/bin/env bash
# Copyright 2019 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# get_root_path returns the root path of the kinder source tree
get_root_path() {
echo "$(git rev-parse --show-toplevel)"
}

# cd_root_path cds to the root path of the kinder source tree
cd_root_path() {
cd "$(get_root_path)" || exit
}
88 changes: 88 additions & 0 deletions hack/verify-all.sh
Original file line number Diff line number Diff line change
@@ -0,0 +1,88 @@
#!/usr/bin/env bash
# Copyright 2019 The Kubernetes Authors.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
# http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

set -o errexit
set -o nounset
set -o pipefail

# shellcheck source=/dev/null
source "$(dirname "$0")/utils.sh"

# set REPO_PATH
REPO_PATH=$(get_root_path)
cd "${REPO_PATH}"

# exit code, if a script fails we'll set this to 1
res=0

# run all verify scripts, optionally skipping any of them

if [[ "${VERIFY_WHITESPACE:-true}" == "true" ]]; then
echo "[*] Verifying whitespace..."
hack/verify-whitespace.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_SPELLING:-true}" == "true" ]]; then
echo "[*] Verifying spelling..."
hack/verify-spelling.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_BOILERPLATE:-true}" == "true" ]]; then
echo "[*] Verifying boilerplate..."
hack/verify-boilerplate.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_GOFMT:-true}" == "true" ]]; then
echo "[*] Verifying gofmt..."
hack/verify-gofmt.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_GOLINT:-true}" == "true" ]]; then
echo "[*] Verifying golint..."
hack/verify-golint.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_GOVET:-true}" == "true" ]]; then
echo "[*] Verifying govet..."
hack/verify-govet.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_DEPS:-true}" == "true" ]]; then
echo "[*] Verifying deps..."
hack/verify-deps.sh || res=1
cd "${REPO_PATH}"
fi

if [[ "${VERIFY_GOTEST:-true}" == "true" ]]; then
echo "[*] Verifying gotest..."
hack/verify-gotest.sh || res=1
cd "${REPO_PATH}"
fi

# exit based on verify scripts
if [[ "${res}" = 0 ]]; then
echo ""
echo "All verify checks passed, congrats!"
else
echo ""
echo "One or more verify checks failed! See output above..."
fi
exit "${res}"
174 changes: 174 additions & 0 deletions hack/verify-boilerplate.go
Original file line number Diff line number Diff line change
@@ -0,0 +1,174 @@
/*
Copyright 2019 The Kubernetes Authors.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at
http://www.apache.org/licenses/LICENSE-2.0
Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package main

import (
"errors"
"fmt"
"io/ioutil"
"os"
"regexp"
"strings"
)

const (
yearPlaceholder = "YEAR"
boilerPlateStart = "Copyright "
boilerPlateEnd = "limitations under the License."
)

var (
supportedExt = []string{".go", ".py", ".sh"}
yearRegexp = regexp.MustCompile("(20)[0-9][0-9]")
boilerPlate = []string{
boilerPlateStart + yearPlaceholder + " The Kubernetes Authors.",
"",
`Licensed under the Apache License, Version 2.0 (the "License");`,
"you may not use this file except in compliance with the License.",
"You may obtain a copy of the License at",
"",
" http://www.apache.org/licenses/LICENSE-2.0",
"",
"Unless required by applicable law or agreed to in writing, software",
`distributed under the License is distributed on an "AS IS" BASIS,`,
"WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.",
"See the License for the specific language governing permissions and",
boilerPlateEnd,
}
)

// trimLeadingComment strips a single line comment characters such as # or //
// at the exact beginning of a line, but also the first possible space character after it.
func trimLeadingComment(line, c string) string {
if strings.Index(line, c) == 0 {
x := len(c)
if len(line) == x {
return ""
}
if line[x] == byte(' ') {
return line[x+1:]
}
return line[x:]
}
return line
}

// verifyFileExtension verifies if the file extensions is supported
func isSupportedFileExtension(filePath string) bool {
// check if the file has an extension
idx := strings.LastIndex(filePath, ".")
if idx == -1 {
return false
}

// check if the file has a supported extension
ext := filePath[idx : idx+len(filePath)-idx]
for _, e := range supportedExt {
if e == ext {
return true
}
}
return false
}

// verifyBoilerplate verifies if a string contains the boilerplate
func verifyBoilerplate(contents string) error {
idx := 0
foundBoilerplateStart := false
lines := strings.Split(contents, "\n")
for _, line := range lines {
// handle leading comments
line = trimLeadingComment(line, "//")
line = trimLeadingComment(line, "#")

// find the start of the boilerplate
bpLine := boilerPlate[idx]
if strings.Contains(line, boilerPlateStart) {
foundBoilerplateStart = true

// validate the year of the copyright
yearWords := strings.Split(line, " ")
expectedLen := len(strings.Split(boilerPlate[0], " "))
if len(yearWords) != expectedLen {
return fmt.Errorf("copyright line should contain exactly %d words", expectedLen)
}
if !yearRegexp.MatchString(yearWords[1]) {
return fmt.Errorf("cannot parse the year in the copyright line")
}
bpLine = strings.ReplaceAll(bpLine, yearPlaceholder, yearWords[1])
}

// match line by line
if foundBoilerplateStart {
if line != bpLine {
return fmt.Errorf("boilerplate line %d does not match\nexpected: %q\ngot: %q", idx+1, bpLine, line)
}
idx++
// exit after the last line is found
if strings.Index(line, boilerPlateEnd) == 0 {
break
}
}
}

if !foundBoilerplateStart {
return errors.New("the file is missing a boilerplate")
}
if idx < len(boilerPlate) {
return errors.New("boilerplate has missing lines")
}
return nil
}

// verifyFile verifies if a file contains the boilerplate
func verifyFile(filePath string) error {
if len(filePath) == 0 {
return errors.New("empty file name")
}

if !isSupportedFileExtension(filePath) {
fmt.Printf("skipping %q: unsupported file type\n", filePath)
return nil
}

// read the file
b, err := ioutil.ReadFile(filePath)
if err != nil {
return err
}

return verifyBoilerplate(string(b))
}

func main() {
if len(os.Args) < 2 {
fmt.Println("usage: " +
"go run verify-boilerplate.go <path-to-file> <path-to-file> ...")
os.Exit(1)
}

hasErr := false
for _, filePath := range os.Args[1:] {
if err := verifyFile(filePath); err != nil {
fmt.Printf("error validating %q: %v\n", filePath, err)
hasErr = true
}
}
if hasErr {
os.Exit(1)
}
}
Loading

0 comments on commit 3196c0d

Please sign in to comment.